annotate scripts/build_pd_heavy.sh @ 510:85ba865d3845 prerelease

moved hvresources/heavy_render.cpp to hvresources/render.cpp
author Giulio Moro <giuliomoro@yahoo.it>
date Wed, 22 Jun 2016 03:28:26 +0100
parents e9821d65b9ba
children 633ade85e798
rev   line source
giuliomoro@425 1 #!/bin/sh
chris@160 2
chris@160 3 # shell script for automatic uploading/compiling of pd patch onto bbb
chris@160 4 # Christian Heinrichs 2015
chris@160 5 #
chris@160 6
giuliomoro@431 7 trap "{ echo "";exit 0; }" 2
giuliomoro@203 8
chris@160 9 workingdir=".."
chris@160 10 pdpath=""
giuliomoro@398 11 NO_UPLOAD="0"
giuliomoro@203 12 WATCH="0"
giuliomoro@203 13 FORCE="0"
giuliomoro@203 14 #make sure the paths have the trailing / .
giuliomoro@431 15 projectpath="../tmp/heavy/hvtemp/"
giuliomoro@295 16 BBB_DEFAULT_PROJECT_NAME="heavyProject"
chris@160 17 COMMAND_ARGS=
chris@160 18 RUN_PROJECT=1
chris@160 19 RUN_IN_FOREGROUND=0
chris@160 20 RUN_WITHOUT_SCREEN=1
giuliomoro@203 21 BELA_PYTHON27=
giuliomoro@203 22
giuliomoro@462 23 SCRIPTDIR=$(dirname "$0")
giuliomoro@462 24 [ -z $SCRIPTDIR ] && SCRIPTDIR="./" || SCRIPTDIR=$SCRIPTDIR/
giuliomoro@481 25 [ -z $HVRESOURCES_DIR ] && HVRESOURCES_DIR=$SCRIPTDIR/hvresources/
giuliomoro@462 26 . $SCRIPTDIR.bela_common || { echo "You must be in Bela/scripts to run these scripts" | exit 1; }
giuliomoro@447 27
giuliomoro@203 28 if [ -z "$BELA_PYTHON27" ]; then
giuliomoro@203 29 for PY in python python2.7 ; do
giuliomoro@428 30 python --version 2>&1 | grep "2\.7" >/dev/null 2>&1
giuliomoro@203 31 if [ $? -eq 0 ]; then
giuliomoro@203 32 BELA_PYTHON27=$PY
giuliomoro@203 33 break;
giuliomoro@203 34 fi;
giuliomoro@203 35 done;
giuliomoro@203 36 fi;
giuliomoro@203 37
giuliomoro@203 38 if [ -z "$BELA_PYTHON27" ]; then
giuliomoro@203 39 echo "It looks like you might not have python2.7 installed. If you do, please specify the path
giuliomoro@403 40 to your python2.7 executable in the environmental variable \$BELA_PYTHON27"
giuliomoro@203 41 exit 1;
giuliomoro@203 42 fi;
giuliomoro@203 43
chris@160 44
giuliomoro@430 45 usage ()
chris@160 46 {
giuliomoro@203 47 printf "\nUSAGE: build_pd.sh [[-i input folder containing _main.pd file ]\
giuliomoro@445 48 [-o output folder for temp heavy project .c files (default $projectpath)]\
giuliomoro@492 49 [-b remote path to copy to (default ~/Bela)] | [-h] | [-w|--watch] | [-n|--noupload] | [-r|--release arg]\n"
giuliomoro@203 50 printf "\nexample: build_pd.sh -i ../projects/heavy/pd/hello-world -o ../projects/heavy/hello-world\n"
giuliomoro@445 51 echo "If --watch is selected, the script will check every 1s for any file that is modified in the source folder, which re-triggers\
giuliomoro@445 52 the building process.
giuliomoro@403 53 If --screen is selected, the prompt returns to the user after launching Bela in a screen on the target device.
giuliomoro@203 54 If --screen and --watch are combined, while the process is running in the screen, modifications to the source files will \
giuliomoro@403 55 still trigger a new build.
giuliomoro@403 56 -r allows to build against a specific Heavy release. Default is the most recent version.
giuliomoro@403 57 "
chris@160 58 }
chris@160 59
chris@160 60 while [ "$1" != "" ]; do
chris@160 61 case $1 in
giuliomoro@442 62 -b | --belaPath ) shift
giuliomoro@295 63 BBB_BELA_HOME=$1
chris@160 64 ;;
chris@160 65 -i | --input ) shift
chris@160 66 pdpath=$1
chris@160 67 ;;
chris@160 68 -o | --output ) shift
chris@160 69 projectpath=$1
chris@160 70 ;;
giuliomoro@403 71 -r | --release ) shift
giuliomoro@403 72 release=$1
giuliomoro@403 73 ;;
giuliomoro@203 74 -s | --screen ) RUN_WITHOUT_SCREEN="0"
giuliomoro@203 75 ;;
giuliomoro@203 76 -w | --watch ) WATCH=1
giuliomoro@203 77 ;;
giuliomoro@442 78 -n | --noupload ) NO_UPLOAD=1
giuliomoro@398 79 ;;
chris@160 80 -h | --help ) usage
chris@160 81 exit
chris@160 82 ;;
chris@160 83 * ) usage
chris@160 84 exit 1
chris@160 85 esac
chris@160 86 shift
chris@160 87 done
chris@160 88
giuliomoro@492 89 [ -z "$ENZIENAUDIO_COM_PATCH_NAME" ] && ENZIENAUDIO_COM_PATCH_NAME=bela
giuliomoro@442 90 [ "$NO_UPLOAD" -eq 0 ] && [ -z "$pdpath" ] && { echo "Error: a path to the source folder should be provided"; exit 1; }
giuliomoro@442 91
giuliomoro@439 92 if [ -z "$release" ]
giuliomoro@403 93 then
giuliomoro@403 94 RELEASE_STRING=
giuliomoro@403 95 else
giuliomoro@403 96 RELEASE_STRING="-r $release"
giuliomoro@403 97 fi
chris@190 98
giuliomoro@431 99 #create destination folder if it does not exist"
giuliomoro@431 100 mkdir -p "$projectpath"
giuliomoro@431 101
giuliomoro@442 102 # These files will be cleared from $projectpath before calling uploader.py
giuliomoro@442 103 #TODO: get a reliable, exhaustive, up-to-date list.
giuliomoro@488 104 HEAVY_FILES='Heavy* Hv*'
giuliomoro@445 105
giuliomoro@445 106 set_date
giuliomoro@445 107 reference_time_file="$projectpath"/
giuliomoro@490 108
giuliomoro@430 109 uploadBuildRun(){
giuliomoro@398 110 if [ $NO_UPLOAD -eq 0 ]; then
giuliomoro@398 111 # remove old static files to avoid obsolete errors
giuliomoro@442 112 # make sure the path is not empty, so avoiding to rm -rf / by mistake
giuliomoro@442 113 [ -z $projectpath ] && { echo 'ERROR: $projectpath is empty.'; exit 0; }
giuliomoro@398 114 # use -rf to prevent warnings in case they do not exist
giuliomoro@442 115 for file in $HEAVY_FILES
giuliomoro@442 116 do
giuliomoro@442 117 rm -rf "$projectpath"/$file
giuliomoro@442 118 done
giuliomoro@203 119
giuliomoro@398 120 # invoke the online compiler
giuliomoro@481 121 "$BELA_PYTHON27" $HVRESOURCES_DIR/uploader.py "$pdpath"/ -n $ENZIENAUDIO_COM_PATCH_NAME -g c -o "$projectpath" $RELEASE_STRING ||\
giuliomoro@442 122 { echo "ERROR: an error occurred while executing the uploader.py script"; exit 1; }
chris@160 123 fi;
chris@160 124
giuliomoro@203 125 echo "";
giuliomoro@442 126
giuliomoro@442 127 # Test that files have been retrieved from the online compiler.
giuliomoro@442 128 # TODO: find a more reliable way of doing this. e.g.: have uploader.py fail with a non-zero error code.
giuliomoro@442 129 for file in $HEAVY_FILES;
giuliomoro@442 130 do
giuliomoro@488 131 ls "$projectpath"/$file >/dev/null 2>&1 || { printf "The online compiler did not return all the files or failed without notice, please try again and/or change HEAVY_FILES to be less strict.\n\n"; exit 1; }
giuliomoro@442 132 done
giuliomoro@481 133
giuliomoro@442 134 # Apply any Bela-specific patches here
giuliomoro@481 135 cp "$HVRESOURCES_DIR/HvUtils.h" $projectpath/ || exit 1;
giuliomoro@203 136
giuliomoro@398 137 BBB_PROJECT_FOLDER=$BBB_PROJECT_HOME"/"$BBB_PROJECT_NAME #make sure there is no trailing slash here
giuliomoro@398 138 BBB_NETWORK_TARGET_FOLDER=$BBB_ADDRESS:$BBB_PROJECT_FOLDER
giuliomoro@398 139
giuliomoro@203 140 # check how to copy/sync render.cpp file...
giuliomoro@473 141 # check if custom heavy/render.cpp file is provided in the input folder
giuliomoro@442 142 # TODO: extend this to all non-Pd files
giuliomoro@473 143 CUSTOM_RENDER_SOURCE_PATH="$pdpath/heavy/render.cpp"
giuliomoro@442 144 if [ -f "$CUSTOM_RENDER_SOURCE_PATH" ]; then
giuliomoro@473 145 echo "Found custom heavy/render.cpp file in input folder, using that one instead of the default one.";
giuliomoro@479 146 cp "$CUSTOM_RENDER_SOURCE_PATH" "$projectpath/render.cpp" || exit 1
giuliomoro@398 147 else
giuliomoro@510 148 echo "Using Heavy default render.cpp"
giuliomoro@510 149 cp "$HVRESOURCES_DIR/render.cpp" "$projectpath/render.cpp" || exit 1
giuliomoro@442 150 fi
giuliomoro@442 151
giuliomoro@442 152 echo "Updating files on board..."
giuliomoro@442 153 # HvContext* files tend to hang when transferring with rsync because they are very large and -c checksum takes a lot, I guess
giuliomoro@445 154
giuliomoro@445 155 touch $reference_time_file
giuliomoro@445 156 # Transfer the files
giuliomoro@492 157 rsync -ac --out-format=" %n" --no-t --delete-during --exclude='HvContext_'$ENZIENAUDIO_COM_PATCH_NAME'.*' --exclude=build --exclude=$BBB_PROJECT_NAME "$projectpath"/ "$BBB_NETWORK_TARGET_FOLDER" &&\
giuliomoro@445 158 { [ $NO_UPLOAD -eq 1 ] || scp "$projectpath"/HvContext* $BBB_NETWORK_TARGET_FOLDER; } ||\
giuliomoro@442 159 { echo "ERROR: while synchronizing files with the BBB. Is the board connected?"; exit 1; }
chris@160 160
giuliomoro@445 161 # TODO: rsync should upload a list of modified files, so that the corresponding objects can be deleted
giuliomoro@492 162 # TODO: this should be run only when Heavy_bela.h changes. Otherwise render is recompiled every time for no good reason
giuliomoro@445 163 #ssh $BBB_ADDRESS "rm -rf ${BBB_PROJECT_FOLDER}/build/render.*"
chris@190 164
giuliomoro@203 165 #produce a list of files which content has changed (not just the date)
giuliomoro@492 166 # remove old executable to force re-linking
giuliomoro@445 167 #if [ $NO_UPLOAD -eq 0 ]; then
giuliomoro@445 168 # ssh $BBB_ADDRESS "rm -rf "$BBB_PROJECT_FOLDER/$BBB_PROJECT_NAME;
giuliomoro@445 169 #fi;
giuliomoro@442 170 # Make new Bela executable and run
giuliomoro@203 171 # It does not look very nice that we type the same things over and over
giuliomoro@203 172 # but that is because each line is an ssh session in its own right
giuliomoro@329 173 MAKE_COMMAND="make stop -C $BBB_BELA_HOME PROJECT='$BBB_PROJECT_NAME' CL='$COMMAND_ARGS'"
giuliomoro@203 174 if [ $RUN_PROJECT -eq 0 ]
giuliomoro@203 175 then
giuliomoro@203 176 echo "Building project..."
giuliomoro@329 177 ssh $BBB_ADDRESS "$MAKE_COMMAND"
giuliomoro@203 178 else
giuliomoro@203 179 echo "Building and running project..."
giuliomoro@445 180 if [ $WATCH -eq 1 ]
giuliomoro@445 181 then
giuliomoro@445 182 # try to emulate run_without_screen: run with fifo
giuliomoro@490 183 if [ $RUN_WITHOUT_SCREEN -eq 1 ];
giuliomoro@490 184 then
giuliomoro@490 185 ssh $BBB_ADDRESS "$MAKE_COMMAND runscreenfifo" & BACKGROUND_PROCESS_PID=$!
giuliomoro@490 186 # run this in the background, it will be killed anyhow when the process stops.
giuliomoro@490 187 # Either with the trap below or in another way
giuliomoro@490 188 trap "kill $BACKGROUND_PROCESS_PID; exit 0;" 2 9
giuliomoro@490 189 # add the line below to the trap if you want to kill the process on the board when you exit the script
giuliomoro@490 190 # ssh -o ConnectTimeout 2 $BBB_ADDRESS make --no-print-directory -C $BBB_BELA_HOME stop ;
giuliomoro@490 191 else
giuliomoro@490 192 ssh $BBB_ADDRESS "$MAKE_COMMAND runscreen"
giuliomoro@490 193 fi
giuliomoro@445 194 elif [ $RUN_WITHOUT_SCREEN -eq 1 ]
giuliomoro@203 195 then
giuliomoro@329 196 ssh -t $BBB_ADDRESS "$MAKE_COMMAND run"
giuliomoro@203 197 elif [ $RUN_IN_FOREGROUND -eq 1 ]
giuliomoro@203 198 then
giuliomoro@203 199 # Run in screen without detaching
giuliomoro@329 200 ssh -t $BBB_ADDRESS "$MAKE_COMMAND runscreenfg"
giuliomoro@445 201 else
giuliomoro@203 202 # Run in screen and detach
giuliomoro@445 203 ssh $BBB_ADDRESS "$MAKE_COMMAND runscreen"
giuliomoro@203 204 fi
giuliomoro@203 205 fi
giuliomoro@403 206 } #uploadBuildRun
giuliomoro@203 207
giuliomoro@403 208 uploadBuildRun
giuliomoro@203 209
giuliomoro@203 210 if [ $WATCH -ne 0 ]; then
giuliomoro@445 211 BACK_NO_UPLOAD=$NO_UPLOAD
giuliomoro@445 212 while true
giuliomoro@445 213 do
giuliomoro@481 214 # actually we are watching multiple paths : $pdpath and $HVRESOURCES_DIR
giuliomoro@481 215 # so that it is easier to edit hvresources code without risk of being
giuliomoro@481 216 # overwritten, but we avoid mentioning it to the end user, otherwise they
giuliomoro@481 217 # get confused.
giuliomoro@445 218 echo "Waiting for changes in $pdpath, or press ctrl-c to terminate"
giuliomoro@481 219 while sleep 1
giuliomoro@481 220 do
giuliomoro@481 221 folder_has_changed "$pdpath" "$reference_time_file" && {
giuliomoro@481 222 echo "Content of $pdpath has changed"
giuliomoro@481 223 break
giuliomoro@481 224 }
giuliomoro@481 225 folder_has_changed "$HVRESOURCES_DIR" "$reference_time_file" && {
giuliomoro@481 226 echo "Content of $pdpath has changed"
giuliomoro@481 227 break
giuliomoro@481 228 }
giuliomoro@481 229 done
giuliomoro@445 230 echo "Files changed"
giuliomoro@445 231 # if .pd files did not change, no point in re-uploading
giuliomoro@445 232 folder_has_changed "$pdpath" "$reference_time_file" "\.pd" &&\
giuliomoro@445 233 NO_UPLOAD=$BACK_NO_UPLOAD || NO_UPLOAD=1
giuliomoro@445 234 uploadBuildRun
giuliomoro@445 235 done
chris@160 236 fi;